/*
===============================================================================

	FILE:	vec3fv.h
	
	CONTENTS:
	
		Face Fixer - SIGGRAPH 2000 demonstration software
	
	PROGRAMMERS:
	
		Martin Isenburg@cs.unc.edu  (with ideas stolen from Kenny Hoff)
	
	COPYRIGHT:
	
		Copyright (C) 2000  Martin Isenburg (isenburg@cs.unc.edu)
		
		This software is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	
	CHANGE HISTORY:
	
		28 April 2000 -- Martin - finalized for SIGGRAPH submission.
	
===============================================================================
*/
#ifndef VEC3FV_H
#define VEC3FV_H

void VecSet3fv(float v[3], float x, float y, float z);
void VecCopy3fv(float v[3], float a[3]);

void VecSelfScalarMult3fv(float v[3], float s);
void VecSelfScalarDiv3fv(float v[3], float s);
void VecSelfNegate3fv(float v[3]);

void VecSelfAdd3fv(float v[3], float a[3]);
void VecSelfSubtract3fv(float v[3], float a[3]);

void VecAdd3fv(float c[3], float a[3], float b[3]);
void VecSubtract3fv(float c[3], float a[3], float b[3]);

int VecEqual3fv(float a[3], float b[3]);

void VecNormalize3fv(float v[3]);

float VecLength3fv(float v[3]);
float VecDotProd3fv(float a[3], float b[3]);

void VecCrossProd3fv(float c[3], float a[3], float b[3]);

void VecUpdateMinMax3fv(float min[3], float max[3], float v[3]);

void VecCcwNormal3fv(float n[3], float a[3], float b[3], float c[3]);

#endif
